#include "board.h"
#include "myRadio.h"
#include "myRadio_gpio.h"

/**-------------------------radio include----------------------------------**/
#include "RF.h"
#include "rf_setting.h"
/**-------------------------radio include end----------------------------------**/

static int8_t rfTxPower;
static uint32_t rfFrequence;
static uint32_t rfBaudrate;
static rfRxCallBack rxCb;
static uint8_t rfRxBuffer[255];
static uint32_t rf_handle;
static uint8_t rf_workProcess;
static uint8_t chipType;
/**-------------------------radio params----------------------------------**/
static bool rf_irq;
/**-------------------------radio params end----------------------------------**/
void myRadio_delay(uint32_t time_ms)
{
    uint32_t i, j;
    i = time_ms;
    while (i --)
    {
        for ( j = 0; j < 14000; j++)
        {
            ;
        }
    }
}
/**
 * @brief IOжϻص
 *      IOڲжϺִиú
 *      ڽƵжӦ
 * 
 * @param index 
 */
void myRadio_gpioCallback(uint8_t index)
{
    rf_irq = true;
}
/**
 * @brief Ƶʼ
 * 
 * @param agr0 
 * @param agr1_ptr ߹״̬Ӧص
 *          صⲿʹã@rfRxCallBack
 */
void myRadio_init(int agr0, void *agr1_ptr)
{
    myRadio_gpio_init(myRadio_gpioCallback);
    
/**-------------------------radio init----------------------------------**/
    RF_Init(rfBaudrate, chipType);
		
    //ȡ汾ţڲspiǷ
    uint16_t reversion = 0;
    RF_ReadBuf(REV, (uint8_t *)&reversion, 2);
    if (reversion != 0X503C)
    {
        while(1);
    }
    
/**-------------------------radio init end----------------------------------**/
    RF_EXT_PA_TO_IDLE();
    if ((rfRxCallBack )agr1_ptr)
    {
        rxCb = (rfRxCallBack )agr1_ptr;
    }
    rf_handle = 0xe5;
}
/**
 * @brief Ƶײִг
 *      Ҫѭִ
 * 
 */
void myRadio_process(void)
{
    uint8_t   bMain_IT_Status;
    rfRxPacket_ts rfRxPacket;
    status_tu status;

    if (rf_handle == 0)
    {
        return;
    }
    if (rf_irq == false)
    {
        return;
    }
    rf_irq = false;
    if ((rf_workProcess != 1) && (rf_workProcess != 2))
    {
        return;
    }
    rf_workProcess = 0;
    status.value = RF_GetStatus();
    if (status.bits.RX_DR)
    {
        status.bits.RX_DR = 0;
        rfRxPacket.len = 12;
        RF_ReadBuf(R_RX_PAYLOAD, rfRxPacket.payload, rfRxPacket.len);  
        rfRxPacket.rssi = 127;
        RF_ClearFIFO();
        RF_ClearStatus (); 
        rxCb(RX_STA_SECCESS, rfRxPacket);
    }
    //ͳɹж
    //߷ͺյACKж
    if (status.bits.TX_DS)
    {
        status.bits.TX_DS = 0;
        RF_ClearFIFO();
        RF_ClearStatus (); 
        rxCb(TX_STA_SECCESS, rfRxPacket);
    }
    //fifoж
    if (status.bits.TX_FULL)
    {
        
    }
    //شж
    if (status.bits.MAX_RT)
    {
        
    }
    //Զȡpipe ж
    if (status.bits.RX_P_NO <= 0x05)
    {
        
    }
    //RX fifoΪж
    if (status.bits.RX_P_NO == 0x07)
    {
        
    }
    if (status.value)
    {
        RF_ClearFIFO();
        RF_ClearStatus (); 
    }
}
/**
 * @brief ˳Ƶ
 * 
 */
void myRadio_abort(void)
{
    if (rf_handle == 0)
    {
        return;
    }
    RF_EXT_PA_TO_IDLE();
    rf_workProcess = 0;
    if (rf_workProcess == 0xa5)
    {
        RF_Init(rfBaudrate, chipType);
    }
    
    RF_powerDown();
}
/**
 * @brief ȡƵƵ
 * 
 * @return uint32_t 
 */
uint32_t myRadio_getFrequency(void)
{
    if (rf_handle == 0)
    {
        return 0;
    }
    return rfFrequence;
}
/**
 * @brief ƵƵ
 * 
 * @param freq 
 *      Ƶ㣬λHz
 */
void myRadio_setFrequency(uint32_t freq)
{

    rfFrequence = freq;

    RF_setFreq(rfFrequence / 1000000);
    RF_CalVco(Dem_cal1_data);
}
/**
 * @brief ȡ书
 * 
 * @return int8_t 
 */
int8_t myRadio_getTxPower(void)
{

    return rfTxPower;
}
/**
 * @brief ÷书
 * 
 * @param power 
 *          λdbm
 */
void myRadio_setTxPower(int8_t power)
{

    rfTxPower = power;
    RF_SetPower(RF_cal1_data, rfTxPower);	
}
/**
 * ȡƵ
 * @param : br->
*/
uint32_t myRadio_getBaudrate(void)
{
    if (rf_handle == 0)
    {
        return 0;
    }
    return rfBaudrate;
}
/**
 * Ƶ
 * @param : br->
*/
void myRadio_setBaudrate(uint32_t br)
{

    rfBaudrate = br;

}
/**
 * @brief ģͺ
 * 
 * @param type 
 */
void myRadio_setChipType(uint8_t type)
{
    chipType = type;
}
/**
 * @brief ȡģͺ
 * 
 * @return uint8_t 
 */
uint8_t myRadio_getChipType(void)
{
    return chipType;
}
int16_t myRadio_getRssi(void)
{
    return 0;
}
/**
 * @brief ߷ݰ
 * 
 * @param packet 
 */
void myRadio_transmit(rfTxPacket_ts *packet)
{
    if (rf_handle == 0)
    {
        return;
    }
    RF_EXT_PA_TO_TX();
    if (rf_workProcess != 1)
    {
        rf_workProcess = 1;
        RF_TxMode();
    }
    rf_workProcess = 1;
    RF_Tx_TransmintData(packet->payload, PAYLOAD_WIDTH);
}
/**
 * @brief ߽
 * 
 */
void myRadio_receiver(void)
{ 
    if (rf_handle == 0)
    {
        return;
    }
    RF_EXT_PA_TO_RX();
    rf_workProcess = 2;
    RF_RxMode();
}
void myRadio_setCtrl(controlMode_te mode, uint32_t value)
{
    if (rf_handle == 0)
    {
        return;
    }
    myRadio_init(0, 0);
    switch (mode)
    {
    case RADIO_EXT_CONTROL_TX_UNMODULATED:
    case RADIO_EXT_CONTROL_TX_MODULATED:
    {
        rf_workProcess = 0xa5;
        RF_EXT_PA_TO_TX();
        myRadio_setTxPower(rfTxPower);
        RF_Carrier();
        // RF_setFreq(rfFrequence / 1000000);
        myRadio_delay(100);
        myRadio_setFrequency(rfFrequence);
    }
        break;
    case RADIO_EXT_CONTROL_RX_SENSITIVITY:
    {
        RF_EXT_PA_TO_RX();
        RF_setFreq(rfFrequence / 1000000);
        myRadio_receiver();
    }
        break;
    
    default:
        break;
    }
}

/**-------------------------radio funtion----------------------------------**/

/**-------------------------radio funtion end----------------------------------**/
