
#ifndef __MYRADIO_GPIO_H_
#define __MYRADIO_GPIO_H_

#include <stdint.h>

#include "stm32f10x.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_spi.h"
#include "board.h"

#define SPI_HARD
typedef void (*RADIO_GPIO_CALLBACK)(uint8_t index);

//-------------射频模块引脚映射到转接板排针---------------
//
#define RF_PAN3020_IRQ_PIN           BOARD_PIN_SPI_GPIOA  //
#define RF_PAN3020_IRQ_PORT          BOARD_PORT_SPI_GPIOA
#define RF_PAN3020_IRQ               RF_PAN3020_IRQ_PORT, RF_PAN3020_IRQ_PIN          //
#define RF_PAN3020_CE_PIN           BOARD_PIN_SPI_GPIOB  //
#define RF_PAN3020_CE_PORT          BOARD_PORT_SPI_GPIOB
#define RF_PAN3020_CE               RF_PAN3020_CE_PORT, RF_PAN3020_CE_PIN          //

//外部PA和LNA控制脚
#define RF_EXTPA_RE_PIN      BOARD_PIN_SPI_GPIOE  //
#define RF_EXTPA_RE_PORT     BOARD_PORT_SPI_GPIOE
#define RF_EXTPA_RE          RF_EXTPA_RE_PORT, RF_EXTPA_RE_PIN          //
#define RF_EXTPA_TE_PIN      BOARD_PIN_SPI_GPIOE  //
#define RF_EXTPA_TE_PORT     BOARD_PORT_SPI_GPIOE
#define RF_EXTPA_TE          RF_EXTPA_TE_PORT, RF_EXTPA_TE_PIN          //
//-------------射频模块引脚映射到转接板排针---------------END

void RF_PAN3020_CE_H(void);
void RF_PAN3020_CE_L(void);

void RF_EXT_PA_RE_H(void);
void RF_EXT_PA_RE_L(void);
void RF_EXT_PA_TE_H(void);
void RF_EXT_PA_TE_L(void);
#define RF_EXT_PA_TO_TX()   RF_EXT_PA_TE_H();RF_EXT_PA_RE_L()
#define RF_EXT_PA_TO_RX()   RF_EXT_PA_TE_L();RF_EXT_PA_RE_H()
#define RF_EXT_PA_TO_IDLE() RF_EXT_PA_TE_L();RF_EXT_PA_RE_L()

void BOARD_SPI_NSS_H(void);
void BOARD_SPI_NSS_L(void);

void myRadio_gpio_init(RADIO_GPIO_CALLBACK cb);
uint8_t myRadioSpi_rwByte(uint8_t byteToWrite);
void myRadioSpi_wBuffer(uint8_t* pData, uint8_t len);
void myRadioSpi_rBuffer(uint8_t* pData, uint8_t len);

//-------------将封装的API映射到射频模块硬件层---------------
#define SPI_RW(p) myRadioSpi_rwByte(p)
// #define SpiWriteData(p1, p2) myRadioSpi_wBuffer(p2, p1)
// #define SpiReadData(p1, p2) myRadioSpi_rBuffer(p2, p1)

#define CSN_HIGH        BOARD_SPI_NSS_H()
#define CSN_LOW         BOARD_SPI_NSS_L()
#define CE_PIN_HIGH     RF_PAN3020_CE_H()
#define CE_PIN_LOW      RF_PAN3020_CE_L()
//-------------将封装的API映射到射频模块硬件层---------------END
#endif
